#include <cstdio>
#include <vector>
using namespace std;

struct pt { double x,y; pt(double x, double y) : x(x), y(y) { } };

double det(pt u, pt v) {
    return u.x * v.y - u.y * v.x;
}

double vcp(pt a,pt b,pt c) {
    return det(pt(b.x - a.x, b.y - a.y), pt(c.x - a.x, c.y - a.y));
}



int main() {
    int n,m;
    scanf(" %d %d",&n,&m);
    vector<pt> pts;
    for (int i=0; i<n; i++) {
        double x,y;
        scanf(" %lf %lf",&x,&y);
        pts.push_back(pt(x,y));
    }
    for (int i=0; i<m; i++) {
        double ax,ay,bx,by;
        scanf(" %lf %lf %lf %lf", &ax, &ay, &bx, &by);
        pt a(ax,ay), b(bx,by);
        for (int j=0; j<n; j++) {
            if (vcp(a, b, pts[j]) > 0) {
                printf("L");
            } else {
                printf("R");
            }
        }
        printf("\n");
    }
    return 0;
}