#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
using namespace std;

int main() {
    vector<pair<int,string> > players;
    for (;;) {
        int n;
        scanf("%d",&n);
        if (n == 0) break;
        vector<pair<int,string> > scoreboard;
        int big = 0;
        for (int i=0; i<n; i++) {
            char name[500];
            int score;
            scanf(" %s %d",name,&score);
            scoreboard.push_back(make_pair(-score,name));
            big = max(big, score);
        }
        for (int i=0;i<scoreboard.size(); i++) {
            if (big != 0) scoreboard[i].first = (int)(scoreboard[i].first / double(big) * 100);
            else scoreboard[i].first = 0;
            bool hit = false;
            for (int j=0; j<players.size(); j++) {
                if (players[j].second == scoreboard[i].second) {
                    hit = true;
                    players[j].first += scoreboard[i].first;
                }
            }
            if (!hit) players.push_back(scoreboard[i]);
        }
    }
    sort(players.begin(),players.end());

    for (int i=0; i<players.size(); i++) {
        printf("%s %d\n",players[i].second.c_str(),-players[i].first);
    }
    return 0;
}