#include <cstdio>
#include <vector>
#include <string>
#include <cstring>
using namespace std;

const int dir[4][2] = {{1,0},{-1,0},{0,1},{0,-1}};

int main() {
    int n;
    scanf(" %d",&n);
    vector<bool> cheaters(n, false);

    vector<string> last;
    for (int bd=0;;bd++) {
        vector<string> board;
        char line[500];
        for (int i=0; i<5; i++) {
            scanf(" %s", line);
            board.push_back(line);
        }

        if (bd != 0) {
            int curp = (bd-1)%n;
            int sx=-1,sy=-1;
            int px=-1,py=-1;
            for (int y=0; y<5; y++) {
                for (int x=0; x<5; x++) {
                    if (board[y][x] == '.' && last[y][x] != '.') {
                        for (int i=0; i<4; i++) {
                            int tx = x + dir[i][0];
                            int ty = y + dir[i][1];
                            if (tx < 0 || tx >= 5 || ty < 0 || ty >= 5) continue;
                            if (board[ty][tx] == ('1' + curp) && last[ty][tx] != ('1' + curp)) {
                                sx = x; sy = y; px = tx; py = ty;
                            }
                        }
                        if (sx != -1) goto done;
                        for (int i=0; i<4; i++) {
                            int tx = x + dir[i][0];
                            int ty = y + dir[i][1];
                            if (tx < 0 || tx >= 5 || ty < 0 || ty >= 5) continue;
                            if (board[ty][tx] == ('1' + curp)) {
                                sx = x; sy = y; px = tx; py = ty;
                            }
                        }
                        if (sx != -1) goto done;
                    }
                }
            }
done:;
//            printf("%d,%d,%d,%d\n",sx,sy,px,py);
            if (sx == -1) { cheaters[curp] = true; }
            else {
                vector<string> assumed(last);
                assumed[py][px] = assumed[sy][sx];
                assumed[sy][sx] = '.';
                for (int y=0; y<5; y++) {
                    for (int x=0; x<5; x++) {
                        if (assumed[y][x] != board[y][x]) cheaters[curp] = true;
                    }
                }
            }
        }
        last = board;

        scanf(" %s", line);
        if (strlen(line) == 6) break;
    }
    bool cheated = false;
    for (int i=0; i<cheaters.size(); i++) {
        if (cheaters[i]) cheated = true;
    }
    if (cheated) {
        printf("The cheating player(s) is/are:");
        bool first = true;
        for (int i=0; i<cheaters.size(); i++) {
            if (cheaters[i]) {
                if (first) first = false;
                else printf(",");
                printf(" %d",i+1);
            }
        }
        printf(".\n");
    } else {
        printf("Nobody cheated!\n");
    }
    return 0;
}